#-----------------------------------------------------------------------------
%{?!dist:	%define	dist	.ok}
%define		sname		%(echo %{name} | cut -d '-' -f2)
#-----------------------------------------------------------------------------
Name		:	qt6-qttools
Version		:	6.8.0
Release		:	17.2.0.rel%{?dist}
Summary		:	Qt6 - QtTool components

Packager	:	Osukiss Project	<build-ok@osukiss.org>

License		:	GPL-3.0
URL		:	https://download.qt.io/archive/qt/(vers/rel)/submodules

Source0		:	%{sname}-everywhere-src-%{version}.tar.xz

#-----------------------------------------------------------------------------
BuildRequires	: cmake
BuildRequires	: gcc-c++
BuildRequires	: qt6-qtbase-devel = %{version}
BuildRequires	: qt6-qtdeclarative-devel = %{version}
BuildRequires	: qt6-rpm-macros
BuildRequires	: Vulkan-Headers

#-----------------------------------------------------------------------------
%description
A cross-platform application and UI framework
(Development Tools, QtHelp)

#-----------------------------------------------------------------------------
%files			
%defattr(-,root,root,-)
%license LICENSES/LGPL*
%{_bindir}/assistant-qt6
%{_bindir}/designer*
%{_bindir}/linguist*
%{_bindir}/lrelease*
%{_bindir}/lupdate*
%{_bindir}/qdbus-qt6
%{_bindir}/qdistancefieldgenerator*
%{_qt6_bindir}/assistant*
%{_qt6_bindir}/designer*
%{_qt6_bindir}/linguist*
%{_qt6_bindir}/lrelease*
%{_qt6_bindir}/lupdate*
%{_qt6_bindir}/qdbus*
%{_qt6_bindir}/qdistancefieldgenerator*
%{_qt6_libdir}/libQt6DesignerComponents.so.6*
%{_qt6_libdir}/libQt6Designer.so.6*
%{_qt6_libdir}/libQt6Help.so.6*
%{_qt6_libdir}/libQt6UiTools.so.6*
%{_qt6_libexecdir}/lprodump*
%{_qt6_libexecdir}/lrelease*
%{_qt6_libexecdir}/lupdate*
%{_qt6_libexecdir}/qhelpgenerator*
%{_qt6_libexecdir}/qtattributionsscanner*
%{_qt6_plugindir}/designer/*
%{_qt6_datadir}/phrasebooks/*.qph
 

#=============================================================================
%package		devel
Summary		:	Development files for %{name}

#-----------------------------------------------------------------------------
Requires	:	%{name}			= %{version}
Requires	:	qt6-qtbase-devel	= %{version}

#-----------------------------------------------------------------------------
%description		devel
The %{name}-devel package contains libraries and
header files for developing applications that
use %{name}.

#-----------------------------------------------------------------------------
%files			devel
%defattr(-,root,root,-)
%{_bindir}/lconvert*
%{_bindir}/pixeltool*
%{_bindir}/qdbusviewer*
%{_bindir}/qtdiag*
%{_bindir}/qtplugininfo*
%{_qt6_bindir}/lconvert*
%{_qt6_bindir}/pixeltool*
%{_qt6_bindir}/qdbusviewer*
%{_qt6_bindir}/qtdiag*
%{_qt6_bindir}/qtplugininfo*
%{_qt6_headerdir}/QtQDocCatch/
%{_qt6_headerdir}/QtQDocCatchConversions/
%{_qt6_headerdir}/QtQDocCatchGenerators/
%{_qt6_headerdir}/QtDesigner/
%{_qt6_headerdir}/QtDesignerComponents/
%{_qt6_headerdir}/QtHelp/
%{_qt6_headerdir}/QtUiPlugin
%{_qt6_headerdir}/QtUiTools/
%{_qt6_headerdir}/QtTools/
%{_qt6_libdir}/libQt6Designer*.so
%{_qt6_libdir}/libQt6Help.so
%{_qt6_libdir}/libQt6UiTools.so
%{_qt6_libdir}/cmake/Qt6/FindWrapLibClang.cmake
%{_qt6_libdir}/cmake/Qt6BuildInternals/StandaloneTests/QtToolsTestsConfig.cmake
%{_qt6_libdir}/cmake/Qt6Designer/*.cmake
%{_qt6_libdir}/cmake/Qt6DesignerComponentsPrivate/*.cmake
%{_qt6_libdir}/cmake/Qt6QDocCatchPrivate/*.cmake
%{_qt6_libdir}/cmake/Qt6QDocCatchConversionsPrivate/*.cmake
%{_qt6_libdir}/cmake/Qt6QDocCatchGeneratorsPrivate/*.cmake
%{_qt6_libdir}/cmake/Qt6Help/*.cmake
%{_qt6_libdir}/cmake/Qt6Linguist/*.cmake
%{_qt6_libdir}/cmake/Qt6LinguistTools/*.cmake
%{_qt6_libdir}/cmake/Qt6UiPlugin/*.cmake
%{_qt6_libdir}/cmake/Qt6Tools/*.cmake
%{_qt6_libdir}/cmake/Qt6ToolsTools/*.cmake
%{_qt6_libdir}/cmake/Qt6UiTools/
%{_qt6_archdatadir}/mkspecs/modules/qt_lib_qdoccatch_private.pri
%{_qt6_archdatadir}/mkspecs/modules/qt_lib_qdoccatchconversions_private.pri
%{_qt6_archdatadir}/mkspecs/modules/qt_lib_qdoccatchgenerators_private.pri
%{_qt6_archdatadir}/mkspecs/modules/qt_lib_designer.pri
%{_qt6_archdatadir}/mkspecs/modules/qt_lib_designer_private.pri
%{_qt6_archdatadir}/mkspecs/modules/qt_lib_designercomponents_private.pri
%{_qt6_archdatadir}/mkspecs/modules/qt_lib_help.pri
%{_qt6_archdatadir}/mkspecs/modules/qt_lib_help_private.pri
%{_qt6_archdatadir}/mkspecs/modules/qt_lib_linguist.pri
%{_qt6_archdatadir}/mkspecs/modules/qt_lib_tools_private.pri
%{_qt6_archdatadir}/mkspecs/modules/qt_lib_uiplugin.pri
%{_qt6_archdatadir}/mkspecs/modules/qt_lib_uitools.pri
%{_qt6_archdatadir}/mkspecs/modules/qt_lib_uitools_private.pri
%{_qt6_libdir}/qt6/metatypes/qt6*_metatypes.json
%{_qt6_libdir}/qt6/modules/*.json
%{_qt6_libdir}/pkgconfig/*.pc
 
#=============================================================================
%package		static
Summary		:	Static library files for %{name}

#-----------------------------------------------------------------------------
Requires	:	%{name}			= %{version}
Requires	:	qt6-qtbase-devel	= %{version}

#-----------------------------------------------------------------------------
%description		static
The %{name}-devel package contains static libraries 
for developing applications that use %{name}.

#-----------------------------------------------------------------------------
%files			static
%defattr(-,root,root,-)
%{_qt6_libdir}/libQt6Designer*.prl
%{_qt6_libdir}/libQt6Help.prl
%{_qt6_libdir}/libQt6UiTools.prl

#=============================================================================
%package		examples
Summary		:	Programming examples for %{name}

#-----------------------------------------------------------------------------
Requires	:	%{name}			= %{version}

#-----------------------------------------------------------------------------
%description		examples
Programming examples for %{name}

#-----------------------------------------------------------------------------
%files			examples
%defattr(-,root,root,-)
%{_qt6_examplesdir}/

#=============================================================================
%prep
%setup -q -n %{sname}-everywhere-src-%{version}

#-----------------------------------------------------------------------------
#building application
%build

cmake							\
	-B _bld						\
	-G Ninja					\
	-S .						\
	-D CMAKE_BUILD_TYPE=Release			\
	-D CMAKE_INSTALL_PREFIX=%{_qt6_prefix}		\
	-D CMAKE_INSTALL_LIBDIR=%{_qt6_libdir}		\
	-D CMAKE_MESSAGE_LOG_LEVEL=STATUS		\
	-D INSTALL_ARCHDATADIR=%{_qt6_archdatadir}	\
	-D INSTALL_BINDIR=%{_qt6_bindir}		\
	-D INSTALL_DATADIR=%{_qt6_datadir}		\
	-D INSTALL_DOCDIR=%{_qt6_docdir}		\
	-D INSTALL_LIBDIR=%{_qt6_libdir}		\
	-D INSTALL_LIBEXECDIR=%{_qt6_libexecdir}	\
	-D INSTALL_EXAMPLESDIR=%{_qt6_examplesdir}	\
	-D INSTALL_INCLUDEDIR=%{_qt6_headerdir}		\
	-D INSTALL_MKSPECSDIR=%{_qt6_mkspecsdir}	\
	-D INSTALL_PLUGINSDIR=%{_qt6_plugindir}		\
	-D INSTALL_QMLDIR=%{_qt6_qmldir} 		\
	-D INSTALL_TRANSLATIONSDIR=%{_qt6_translationdir}\
	-D CMAKE_CURRENT_SOURCE_DIR=%{_qt6_datadir}	\
	-D CMAKE_MESSAGE_LOG_LEVEL=STATUS		\

cmake							\
	--build						\
	_bld						\
	--parallel %(/usr/bin/getconf _NPROCESSORS_ONLN)\

#-----------------------------------------------------------------------------
%clean
%{__rm} -rf %{buildroot}

#-----------------------------------------------------------------------------
#installing program
%install
%{__rm} -rf %{buildroot}

DESTDIR=%{buildroot}					\
	cmake						\
	--install					\
	_bld

%{__mkdir_p} %{buildroot}%{_bindir}
pushd %{buildroot}%{_qt6_bindir}
for i in * ; do
  case "${i}" in
   assistant|designer|lconvert|linguist|lrelease|lupdate|pixeltool| \
   qcollectiongenerator|qdbus|qdbusviewer|qhelpconverter|qhelpgenerator| \
   qtplugininfo|qdistancefieldgenerator|qdoc|qtdiag)
      ln -v  ${i} %{buildroot}%{_bindir}/${i}-qt6
      ln -sv ${i} ${i}-qt6
      ;;
    *)
      ln -v  ${i} %{buildroot}%{_bindir}/${i}
      ;;
  esac
done
popd

#-----------------------------------------------------------------------------
%changelog
